"""Find the largest sum of any contiguous subarray."""
import time
from supplementary_code import generate_large_array

a = [-2, 1, -3, 4, -1, 2, 1, -5, 4]


def naive_solution(array):
    max = float('-inf')
    for h in range(0, len(array)):
        sum = 0
        for k in range(h, len(array)):
            sum += array[k]
            if sum > max:
                max = sum
    print(max)
    return max


def proposed_solution(array):
    best_sum = 0
    current_sum = 0
    for x in array:
        current_sum = max(0, current_sum + x)
        best_sum = max(best_sum, current_sum)
    return best_sum


def main():
    array = generate_large_array()
    print("Testing on array of size {}".format(len(array)))

    start = time.time()
    print(naive_solution(array))
    end = time.time()
    print(round(end - start, 3), "seconds")

    start = time.time()
    print(proposed_solution(array))
    end = time.time()
    print(round(end - start, 3), "seconds")


if __name__ == '__main__':
    main()
